<div class="container-fluid p-py-5 projects-override">
  <p-table #dt [scrollable]="true" scrollHeight="500px" [value]="reserveEmployeesInformation"
    [globalFilterFields]="['employeeFullName', 'employeeId']"
    styleClass="p-datatable-striped">
    <ng-template pTemplate="caption">
      <div class="text-center">
        <input pInputText type="text" size="50" placeholder="Search" class="w-auto"
          (input)="dt.filterGlobal(getEventValue($event), 'contains')" />
      </div>
    </ng-template>
    <ng-template pTemplate="header">
      <tr>
        <th [pSortableColumn]="fullNameSortField" style="width: 18%;">
          <span>Employee</span>
          <span>
            <p-sortIcon [field]="fullNameSortField"></p-sortIcon>
          </span>
        </th>
        <th [pSortableColumn]="lastReportTimestampSortField" style="width: 19%;">
          <span>Last report timestamp</span>
          <span>
            <p-sortIcon [field]="lastReportTimestampSortField"></p-sortIcon>
          </span>
        </th>
        <th style="width: 17%;">Reported days for this year</th>
        <th [pSortableColumn]="currentVacationBalance" style="width: 16%;">
          <span>Current vacation balance</span>
          <span>
            <p-sortIcon [field]="currentVacationBalance"></p-sortIcon>
          </span>
        </th>
        <th style="width: 17%;">Penalty amount for this year</th>
        <th style="width: 17%;" [pSortableColumn]="afterVacationTakenSortField" >
          <span>After vacation taken</span>
          <span>
            <p-sortIcon [field]="afterVacationTakenSortField"></p-sortIcon>
          </span>
        </th>
        <th></th>
      </tr>
    </ng-template>
    <ng-template pTemplate="body" let-reserveEmployeeInfo>
      <tr>
        <td>{{ reserveEmployeeInfo.employeeFullName }}</td>
        <td>{{ reserveEmployeeInfo.lastReportTimestamp | date: 'shortDate' }}</td>
        <td>{{ reserveEmployeeInfo.reportedDaysForCurrentYear | number : '1.2-2' }}</td>
        <td>{{ reserveEmployeeInfo.currentVacationBalance | number : '1.2-2' }}</td>
        <td>{{ reserveEmployeeInfo.penaltyAmountForCurrentYear | signedNumber: '1.2-2' }}</td>
        <td>{{ reserveEmployeeInfo.afterVacationTaken | number: '1.2-2' }}</td>
        <td>
          <div class="d-flex justify-content-center">
            <button
              pButton
              label="Set penalty"
              [disabled]="isCurrentMonthJanuary"
              class="p-button-danger"
              (click)="onShowVacationPenaltyDialog(reserveEmployeeInfo)"
            ></button>
          </div>
        </td>
      </tr>
    </ng-template>
  </p-table>
  <p-dialog
    header="Set penalty"
    [(visible)]="penaltyDialogVisible"
    [responsive]="true"
    [resizable]="false"
    [modal]="true"
    [style]="{ 'width': '600px' }"
    showEffect="fade">
    <form [formGroup]="vacationPenaltyForm" (ngSubmit)="onSubmitVacationPenalty()">
      <div class="form-group form-row" style="margin-top: 1rem;">
        <label class="col-form-label offset-md-0 col-md-2 text-md-right">Amount</label>
        <div class="offset-1 offset-md-0 col-md-10">
          <input
            id="amount"
            [placeholder]="vacationPenaltyDefaultAmount"
            formControlName="amount"
            type="text"
            class="w-100"
            pInputText
            (input)="sanitizeAddNumericInput($event)"
          />
          <ng-container *ngIf="showVacationPenaltyFormValidationErrors('amount')">
            <small class="text-danger" *ngIf="vacationPenaltyForm.get('amount').errors?.['required']">Value is required</small>
            <small class="text-danger" *ngIf="vacationPenaltyForm.get('amount').errors?.['min']">Value must be between -30 and -1</small>
            <small class="text-danger" *ngIf="vacationPenaltyForm.get('amount')?.errors?.['max']">Value must be between -30 and -1</small>
            <small class="text-danger" *ngIf="vacationPenaltyForm.get('amount')?.errors?.['pattern']">Invalid input: only numeric values are allowed</small>
          </ng-container>
        </div>
      </div>
      <div class="form-group form-row">
        <label class="col-form-label offset-md-0 col-md-2 text-md-right">Comment</label>
        <div class="offset-1 offset-md-0 col-md-10">
          <textarea
            pInputTextarea
            id="comment"
            formControlName="comment"
            class="w-100"
            style="min-height: 75px;"
            [rows]="3"
            [autoResize]="true"
            ></textarea>
            <ng-container *ngIf="showVacationPenaltyFormValidationErrors('comment')">
              <small class="text-danger" *ngIf="vacationPenaltyForm.get('comment').errors?.['required']">Value is required</small>
              <small class="text-danger" *ngIf="vacationPenaltyForm.get('comment').errors?.['maxlength']">Value must be less than 100 characters long</small>
            </ng-container>
        </div>
      </div>
      <div class="form-group form-row">
        <div class="offset-1 offset-md-2 col-md-2">
          <button pButton label="Submit" [disabled]="vacationPenaltyForm.invalid" type="submit"></button>
        </div>
      </div>
    </form>
  </p-dialog>
</div>
